const dialogCon = document.querySelector('.dialog-container')

const textStyle = {
  fontSize: '16px',
  color: '#333',
  fontWeight: 500,
}
const dialogTitle = ['库存现金', '银行存款', '应收账款', '应付账款']
// const hostApi = 'https://dev.jsptax.com'
const hostApi = 'https://daizhang.jsptax.com'

const axisTick = {
  alignWithLabel: true
}

let listData = []

function init() {
  showCwzbClickFunc()
  // initSzqkCharts()
  // initNsqkCharts()
  getIndexData()

  document.querySelector('.dialog-footer .close-dialog').addEventListener('click', closeDialog)
}

function showCwzbClickFunc() {
  const cwzbCon = document.querySelectorAll('.text-container .num')
  for (let i = 0; i < cwzbCon.length; i++) {
    cwzbCon[i].addEventListener('click', () => showDialog(i))
  }
}

function showDialog(i) {
  document.querySelector('.dialog-title').innerHTML = dialogTitle[i]
  dialogCon.style.display = 'block'
  const footer = document.querySelector('.table-footer')
  if (listData[i].length > 5) {
    document.querySelector('.table-header').style['overflow-y'] = 'scroll'
    document.querySelector('.table-footer').style['overflow-y'] = 'scroll'
  } else {
    document.querySelector('.table-header').style['overflow-y'] = 'unset'
    document.querySelector('.table-footer').style['overflow-y'] = 'unset'
  }
  if (listData[i].length < 5) {
    footer.style['border-top'] = '1px solid rgba(229, 229, 229, 1)'
  } else {
    footer.style['border-top'] = 'unset'
  }

  let listNodeStr
  if (listData[i].length) {
    listNodeStr = listData[i].map(item => {
      return `<div class="table-row"><span>${item.subjectName}</span><span>${item.beginAmount.toFixed(2)}</span><span>${item.endAmount.toFixed(2)}</span></div>`
    })
  } else {
    listNodeStr = [`<div class="table-row-empty">暂无数据</div>`]
  }
  document.querySelector('.data-list-container').innerHTML = listNodeStr.join('')
  const total = listData[i].reduce((acc, cur) => {
    acc.begin += cur.beginAmount
    acc.end += cur.endAmount
    return acc
  }, { begin: 0, end: 0 })

  const spanList = footer.querySelectorAll('span')
  spanList[1].innerHTML = total.begin.toFixed(2)
  spanList[2].innerHTML = total.end.toFixed(2)
  addCloseDialogEvent()
}

function addCloseDialogEvent() {
  const mark = document.querySelector('.dialog-container .mark')
  mark.addEventListener('click', closeDialog)
}

function closeDialog() {
  dialogCon.style.display = 'none'
  // dialogCon.classList.remove('fade-in')
  // dialogCon.classList.add('fade-out')

  // setTimeout(() => {
  //   dialogCon.classList.remove('opacity-1')
  //   dialogCon.style.display = 'none'
  // }, 500)
}

function initSzqkCharts(data) {
  var chartDom = document.querySelector('.szqk-echarts-box');
  var myChart = echarts.init(chartDom);
  var option;

  option = {
    color: ['#5470DE', '#07BEAA', '#FF8D1A', '#AC33C1'],
    title: {
      text: '收支情况（近一年）',
      textStyle,
      subtext: '单位：元'
    },
    tooltip: {
      trigger: 'axis',
      axisPointer: {
        type: 'cross',
        label: {
          backgroundColor: '#6a7985'
        }
      }
    },
    legend: {
      data: ['收入', '成本', '费用', '利润'],
      top: '0%',
      right: '1.5%',
      icon: 'circle',
    },
    grid: {
      left: '0.5%',
      right: '2%',
      bottom: '3%',
      top: '10%',
      containLabel: true
    },
    // dataZoom: [
    //   {
    //     type: 'slider', // 表示滑动条类型的dataZoom
    //     show: true, // 显示滚动条
    //     xAxisIndex: [0], // 控制X轴
    //     start: 0, // 滚动条的起始位置
    //     end: 80, // 滚动条的结束位置，表示初始时展示30%的数据
    //     height: 20,
    //     handleSize: '80%', // 设置控制手柄的大小
    //     handleStyle: {
    //       color: '#fff',
    //       shadowBlur: 3,
    //       shadowColor: 'rgba(0, 0, 0, 0.6)',
    //       shadowOffsetX: 2,
    //       shadowOffsetY: 2
    //     }
    //   },
    //   {
    //     type: 'inside', // 表示内置型dataZoom，可以通过鼠标滚轮和滑动进行操作
    //     xAxisIndex: [0], // 控制X轴
    //     start: 0, // 同上
    //     end: 30, // 同上
    //     zoomOnMouseWheel: true, // 开启鼠标滚轮缩放
    //     moveOnMouseMove: true // 开启鼠标滑动
    //   }
    // ],
    xAxis: [
      {
        type: 'category',
        data: cal1Year(),
        axisTick,
      }
    ],
    yAxis: [
      {
        type: 'value'
      }
    ],
    series: [
      {
        name: '收入',
        type: 'line',
        smooth: true,
        areaStyle: {
          color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
            {
              offset: 0,
              color: 'rgba(84, 112, 222, 0.25)'
            },
            {
              offset: 1,
              color: 'rgba(84, 112, 222, 0)'
            }
          ])
        },
        emphasis: {
          focus: 'series'
        },
        data: data.sr,
      },
      {
        name: '成本',
        type: 'line',
        smooth: true,
        areaStyle: {
          color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
            {
              offset: 0,
              color: 'rgba(7, 190, 170, 0.25)'
            },
            {
              offset: 1,
              color: 'rgba(7, 190, 170, 0)'
            }
          ])
        },
        emphasis: {
          focus: 'series'
        },
        data: data.cb,
      },
      {
        name: '费用',
        type: 'line',
        smooth: true,
        areaStyle: {
          color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
            {
              offset: 0,
              color: 'rgba(255, 141, 26, 0.25)'
            },
            {
              offset: 1,
              color: 'rgba(255, 141, 26, 0)'
            }
          ])
        },
        emphasis: {
          focus: 'series'
        },
        data: data.fy
      },
      {
        name: '利润',
        type: 'line',
        smooth: true,
        areaStyle: {
          color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
            {
              offset: 0,
              color: 'rgba(172, 51, 193, 0.25)'
            },
            {
              offset: 1,
              color: 'rgba(172, 51, 193, 0)'
            }
          ])
        },
        emphasis: {
          focus: 'series'
        },
        data: data.lr
      },
    ]
  };

  myChart.setOption(option);
  window.addEventListener('resize', function () {
    myChart.resize()
  })
}

function initNsqkCharts(data) {
  var chartDom = document.querySelector('.nsqk-echarts-box');
  var myChart = echarts.init(chartDom);
  var option;

  option = {
    color: ['rgba(42, 130, 228, 1)', '#07BEAA', '#FF8D1A', '#AC33C1'],
    tooltip: {
      trigger: 'axis',
      axisPointer: {
        type: 'shadow'
      }
    },
    title: {
      text: '纳税情况（近一年）',
      textStyle,
      subtext: '单位：元'
    },
    grid: {
      left: '0.5%',
      right: '2%',
      bottom: '3%',
      top: '10%',
      containLabel: true
    },
    xAxis: [
      {
        type: 'category',
        data: cal1Year(),
        axisTick
      }
    ],
    yAxis: [
      {
        type: 'value'
      }
    ],
    series: [
      {
        name: '纳税情况',
        type: 'bar',
        barWidth: 27,
        data: data.ns
      }
    ]
  };

  myChart.setOption(option);
  window.addEventListener('resize', function () {
    myChart.resize()
  })
}

async function getIndexData () {
  const searchStr = location.search.substring(1)
  const params = searchStr.split('&').reduce((acc, cur) => {
    const [key, value] = cur.split('=')
    acc[key] = value
    return acc
  }, {})
  const response = await fetch(
    hostApi + '/api/public/wzfCzList',
    // '/api/public/wzfCzList',
    {
      method: 'POST',
      mode: 'cors',
      headers: {
        "Content-Type": "application/json",
        // 'Content-Type': 'application/x-www-form-urlencoded',
      },
      body: JSON.stringify(params)
    }
  )
  const res = await response.json()
  if (res.errNo === 0) {
    document.querySelector('.company-name').innerHTML = res.data.comName
    document.querySelector('.kcxj .num').innerHTML = res.data.amount.kcxjAmount
    document.querySelector('.yhck .num').innerHTML = res.data.amount.yhckAmount
    document.querySelector('.yszk .num').innerHTML = res.data.amount.yszkAmount
    document.querySelector('.yfzk .num').innerHTML = res.data.amount.yfzkAmount
    const period = cal1Year()[0]
    document.querySelector('.table-header-top .period').innerHTML = period
    document.querySelector('.cwzb-container .period').innerHTML = period
    initSzqkCharts(res.data)
    initNsqkCharts(res.data)
    listData = [
      res.data.kcxjList.filter(item => !!item.beginAmount || !!item.endAmount),
      res.data.yhckList.filter(item => !!item.beginAmount || !!item.endAmount),
      res.data.yszkList.filter(item => !!item.beginAmount || !!item.endAmount),
      res.data.yfzkList.filter(item => !!item.beginAmount || !!item.endAmount),
    ]
  } else {
    document.querySelector('.empty').style.display = 'flex'
    document.querySelector('.content-container').style.display = 'none'
  }
  
}

function cal1Year() {
  return Array(12).fill(0).map((_, i) => {
    return dayjs().subtract(i + 1, 'month').format('YYYY年MM月')
    // return dayjs().subtract(12 - i, 'month').format('YYYY年MM月')
  })
}